> some examples of type resolution

- [Interface](interface.en-US.md)
  - [1.1 Basic Types](interface.en-US.md#11-basic-types)
  - [1.2 Union Types](interface.en-US.md#12-union-types)
  - [1.3 Intersection Types](interface.en-US.md#13-intersection-types)
  - [1.4 Array Types](interface.en-US.md#14-array-types)
    - [1.4.1 Basic Array Types](interface.en-US.md#141-basic-array-types)
    - [1.4.2 Complex Array Types](interface.en-US.md#142-complex-array-types)
  - [1.5 Nesting](interface.en-US.md#15-nesting)
    - [1.5.1 Nested Basic Types](interface.en-US.md#151-nested-basic-types)
    - [1.5.2 Nested Union Types](interface.en-US.md#152-nested-union-types)
    - [1.5.3 Nested Intersection Types](interface.en-US.md#153-nested-intersection-types)
    - [1.5.4 Nested Intersection Array Types](interface.en-US.md#154-nested-intersection-array-types)
    - [1.5.5 Nested loop](interface.en-US.md#155-nested-loop)
  - [1.6 Index Types](interface.en-US.md#16-index-types)
- [Modules](module.en-US.md#modules)
  - [1.1 Basic Modules](module.en-US.md#11-basic-modules)
  - [1.2 Named Export Modules](module.en-US.md#12-named-export-modules)
- [Extending Types](extends.en-US.md#extending-types)
  - [1.1 Basic Extending Types](extends.en-US.md#11-basic-extending-types)
  - [1.2 Multiple Extending Types](extends.en-US.md#12-multiple-extending-types)
- [Enums](enum.en-US.md#enums)
  - [1.1 Numeric Enums](enum.en-US.md#11-numeric-enums)
  - [1.2 String Enums](enum.en-US.md#12-string-enums)
  - [1.3 Computed Enums](enum.en-US.md#13-computed-enums)
  - [1.4 Complex Enums](enum.en-US.md#14-complex-enums)
    - [1.4.1 Basic Interface to Enums](enum.en-US.md#141-basic-interface-to-enums)
    - [1.4.2 Complex Interface to Enums](enum.en-US.md#142-complex-interface-to-enums)
- [Generics](generic.en-US.md#generics)
  - [1.1 Basic Generics](generic.en-US.md#11-basic-generics)
  - [1.2 Complex Generics](generic.en-US.md#12-complex-generics)
- [Namespaces](namespace.en-US.md#namespaces)
  - [1.1 Basic Namespaces](namespace.en-US.md#11-basic-namespaces)
  - [1.2 Complex Namespaces](namespace.en-US.md#12-complex-namespaces)
- [Type](type.en-US.md#type)
  - [1.1 Basic Types](type.en-US.md#11-basic-types)
  - [1.2 Complex Types](type.en-US.md#12-complex-types)
    - [1.2.1 Union Types](type.en-US.md#121-union-types)
    - [1.2.2 Union Array Types](type.en-US.md#122-union-array-types)
    - [1.2.3 Import Enums](type.en-US.md#122-import-enums)
- [Utility Types](toolFn.en-US.md#utility-types)
  - [1.1 Utility for Objects](toolFn.en-US.md#11-utility-for-objects)
    - [1.1.1 Omit](toolFn.en-US.md#111-omit)
      - [1.1.1.1 Basic Omit](toolFn.en-US.md#1111-basic-omit)
      - [1.1.1.2 Union Omit](toolFn.en-US.md#1112-union-omit)
      - [1.1.1.3 Import Omit](toolFn.en-US.md#1113-import-omit)
    - [1.1.2 Pick](toolFn.en-US.md#112-pick)
      - [1.1.2.1 Basic Pick](toolFn.en-US.md#1121-basic-pick)
      - [1.1.2.2 Import Pick](toolFn.en-US.md#1122-import-pick)
    - [1.1.3 Record](toolFn.en-US.md#112-record)
      - [1.1.2.1 Basic Record](toolFn.en-US.md#1121-basic-record)
      - [1.1.2.2 Import Record](toolFn.en-US.md#1122-import-record)
- [Annotations](note.en-US.md#annotations)
  - [1.1 Single-line annotations](note.en-US.md#11-single-line-annotations)
  - [1.2 Single-line annotations with default value](note.en-US.md#12-single-line-annotations-with-default-value)
  - [1.3 Multi-line annotations](note.en-US.md#13-multi-line-annotations)
  - [1.4 Multi-line annotations with default value](note.en-US.md#14-multi-line-annotations-with-default-value)
  - [1.5 Mixed annotations with default value](note.en-US.md#15-mixed-annotations-with-default-value)
